package ru.dbotthepony.kommons.util

fun xxhash64(data: String, seed: Long = 0L): ByteArray {
	val digest = XXHash64(seed)
	digest.update(data.toByteArray())
	return digest.digest()
}

fun xxhash32(data: String, seed: Int = 0): ByteArray {
	val digest = XXHash32(seed)
	digest.update(data.toByteArray())
	return digest.digest()
}

fun xxhash64(data: ByteArray, seed: Long = 0L): ByteArray {
	val digest = XXHash64(seed)
	digest.update(data)
	return digest.digest()
}

fun xxhash32(data: ByteArray, seed: Int = 0): ByteArray {
	val digest = XXHash32(seed)
	digest.update(data)
	return digest.digest()
}

fun xxhash64(data: ByteArray, offset: Int, length: Int, seed: Long = 0L): ByteArray {
	val digest = XXHash64(seed)
	digest.update(data, offset, length)
	return digest.digest()
}

fun xxhash32(data: ByteArray, offset: Int, length: Int, seed: Int = 0): ByteArray {
	val digest = XXHash32(seed)
	digest.update(data, offset, length)
	return digest.digest()
}

fun digest2string(hash: ByteArray): String {
	val builder = StringBuilder(hash.size * 2)

	for (b in hash) {
		val s = (b.toInt() and 0xFF).toString(16)
		if (s.length == 1) builder.append("0")
		builder.append(s)
	}

	return builder.toString()
}
